diff --git a/src/Makefile b/src/Makefile
index fe366f72..825c1fe0 100644
--- a/src/Makefile
+++ b/src/Makefile
@@ -119,8 +119,8 @@ $(BINDIR)/term%.o: term%.c
 $(BINDIR)/%.o: %.c
 	$(CC) -c $(DEPOPT) $(CPPFLAGS) $(CCFLAGS) -fstack-check $< -o $(BINDIR)/$*.o
 
-$(BINDIR)/%.o: %.rc %.mft
-	$(RC) --preprocessor '$(CC) -E -xc -DRC_INVOKED $(DEPOPT) $(CPPFLAGS)' $< $(BINDIR)/$*.o
+$(BINDIR)/%.o: %.rc %.h %.mft
+	$(RC) -c 65001 --preprocessor '$(CC) -E -xc -DRC_INVOKED $(DEPOPT) $(CPPFLAGS)' $< $(BINDIR)/$*.o
 	-mv $*.d $(BINDIR)/
 
 exe := $(NAME).exe
diff --git a/src/res.h b/src/res.h
index 78a62322..f11a2ac9 100644
--- a/src/res.h
+++ b/src/res.h
@@ -10,3 +10,13 @@
 // value is already needed before it would be available that way - totally insane!
 // Therefore, its setting is taken out to this common include file.
 #define DIALOG_HEIGHT 182
+
+#define DIALOG_TITLE "Options"
+
+#define DIALOG_FONT "MS Shell Dlg"
+//#define DIALOG_FONT "Tahoma"
+
+//#define DIALOG_FONT "Calibri"
+//#define DIALOG_FONT "Trebuchet MS"
+//#define DIALOG_FONT "Lucida Sans Unicode"
+
diff --git a/src/res.rc b/src/res.rc
index 5536332c..c92cc57f 100644
--- a/src/res.rc
+++ b/src/res.rc
@@ -6,16 +6,10 @@
 
 IDI_MAINICON ICON "../icon/terminal.ico"
 
-#define accept_issue_414
-#ifdef accept_issue_414
 IDD_MAINBOX DIALOGEX DISCARDABLE 32, 8, 256, DIALOG_HEIGHT
 STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_CAPTION | WS_SYSMENU
-#else
-IDD_MAINBOX DIALOG DISCARDABLE 32, 8, 256, DIALOG_HEIGHT
-STYLE DS_MODALFRAME | WS_POPUP | WS_CAPTION | WS_SYSMENU
-#endif
-CAPTION "Options"
-FONT 8, "MS Shell Dlg"
+CAPTION DIALOG_TITLE
+FONT 8, DIALOG_FONT
 CLASS "ConfigBox"
 BEGIN
 END
diff --git a/src/windialog.c b/src/windialog.c
index 8e977dc7..5136c1d1 100644
--- a/src/windialog.c
+++ b/src/windialog.c
@@ -322,6 +322,8 @@ win_open_config(void)
   if (config_wnd)
     return;
 
+  set_dpi_auto_scaling(true);
+
   static bool initialised = false;
   if (!initialised) {
     InitCommonControls();
@@ -350,6 +352,8 @@ win_open_config(void)
   determine_geometry(config_wnd);  // dummy call
 
   ShowWindow(config_wnd, SW_SHOW);
+
+  set_dpi_auto_scaling(false);
 }
 
 void
diff --git a/src/winmain.c b/src/winmain.c
index 25f74bcc..fb790683 100644
--- a/src/winmain.c
+++ b/src/winmain.c
@@ -129,25 +129,32 @@ load_dwm_funcs(void)
   }
 }
 
-#define dont_debug_dpi
+#define debug_dpi
 
 static bool per_monitor_dpi_aware = false;
 uint dpi = 96;
 
 #define WM_DPICHANGED 0x02E0
 const int Process_System_DPI_Aware = 1;
-const int Process_Per_Monitor_DPI_Aware  = 2;
-const int MDT_Effective_DPI = 0;
+const int Process_Per_Monitor_DPI_Aware = 2;
 static HRESULT (WINAPI * pGetProcessDpiAwareness)(HANDLE hprocess, int * value) = 0;
 static HRESULT (WINAPI * pSetProcessDpiAwareness)(int value) = 0;
 static HRESULT (WINAPI * pGetDpiForMonitor)(HMONITOR mon, int type, uint * x, uint * y) = 0;
 
+DECLARE_HANDLE(DPI_AWARENESS_CONTEXT);
+#define DPI_AWARENESS_CONTEXT_UNAWARE           ((DPI_AWARENESS_CONTEXT)-1)
+#define DPI_AWARENESS_CONTEXT_SYSTEM_AWARE      ((DPI_AWARENESS_CONTEXT)-2)
+#define DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE ((DPI_AWARENESS_CONTEXT)-3)
+static DPI_AWARENESS_CONTEXT (WINAPI * pSetThreadDpiAwarenessContext)(DPI_AWARENESS_CONTEXT dpic) = 0;
+static HRESULT (WINAPI * pEnableNonClientDpiScaling)(HWND win) = 0;
+
 static void
-load_shcore_funcs(void)
+load_dpi_funcs(void)
 {
   HMODULE shc = load_sys_library("shcore.dll");
+  HMODULE user = load_sys_library("user32.dll");
 #ifdef debug_dpi
-  printf("load_shcore_funcs shc %d\n", !!shc);
+  printf("load_dpi_funcs shcore %d user32 %d\n", !!shc, !!user);
 #endif
   if (shc) {
     pGetProcessDpiAwareness =
@@ -156,15 +163,36 @@ load_shcore_funcs(void)
       (void *)GetProcAddress(shc, "SetProcessDpiAwareness");
     pGetDpiForMonitor =
       (void *)GetProcAddress(shc, "GetDpiForMonitor");
+  }
+  if (user) {
+    pSetThreadDpiAwarenessContext =
+      (void *)GetProcAddress(user, "SetThreadDpiAwarenessContext");
+    pEnableNonClientDpiScaling =
+      (void *)GetProcAddress(user, "EnableNonClientDpiScaling");
+  }
 #ifdef debug_dpi
-    printf("SetProcessDpiAwareness %d GetProcessDpiAwareness %d GetDpiForMonitor %d\n", !!pSetProcessDpiAwareness, !!pGetProcessDpiAwareness, !!pGetDpiForMonitor);
+  printf("SetProcessDpiAwareness %d GetProcessDpiAwareness %d GetDpiForMonitor %d SetThreadDpiAwarenessContext %d EnableNonClientDpiScaling %d\n", !!pSetProcessDpiAwareness, !!pGetProcessDpiAwareness, !!pGetDpiForMonitor, !!pSetThreadDpiAwarenessContext, !!pEnableNonClientDpiScaling);
 #endif
+}
+
+void
+set_dpi_auto_scaling(bool on)
+{
+  if (pSetThreadDpiAwarenessContext) {
+    if (on)
+      pSetThreadDpiAwarenessContext(DPI_AWARENESS_CONTEXT_UNAWARE);
+    else
+      pSetThreadDpiAwarenessContext(DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE);
   }
 }
 
 static bool
 set_per_monitor_dpi_aware()
 {
+  if (pSetThreadDpiAwarenessContext) {
+    if (pSetThreadDpiAwarenessContext(DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE))
+      return true;
+  }
   if (pSetProcessDpiAwareness && pGetProcessDpiAwareness) {
     HRESULT hr = pSetProcessDpiAwareness(Process_Per_Monitor_DPI_Aware);
     // E_ACCESSDENIED:
@@ -2096,7 +2124,7 @@ main(int argc, char *argv[])
 
   load_dwm_funcs();  // must be called after the fork() above!
 
-  load_shcore_funcs();
+  load_dpi_funcs();
   per_monitor_dpi_aware = set_per_monitor_dpi_aware();
 #ifdef debug_dpi
   printf("per_monitor_dpi_aware %d\n", per_monitor_dpi_aware);
@@ -2276,6 +2304,13 @@ main(int argc, char *argv[])
                         window_style | (cfg.scrollbar ? WS_VSCROLL : 0),
                         x, y, width, height,
                         null, null, inst, null);
+  if (pEnableNonClientDpiScaling) {
+    BOOL res = pEnableNonClientDpiScaling(wnd);
+    (void)res;
+#ifdef debug_dpi
+    printf("EnableNonClientDpiScaling: %d\n", !!res);
+#endif
+  }
 
   // Adapt window position (and maybe size) to special parameters
   // also select monitor if requested
diff --git a/src/winpriv.h b/src/winpriv.h
index 4def39b2..9b36f8e1 100644
--- a/src/winpriv.h
+++ b/src/winpriv.h
@@ -33,6 +33,7 @@ extern void win_init_fonts(int size);
 extern void win_adapt_term_size(bool sync_size_with_font, bool scale_font_with_size);
 
 extern void win_open_config(void);
+extern void set_dpi_auto_scaling(bool on);
 
 extern void win_show_tip(int x, int y, int cols, int rows);
 extern void win_destroy_tip(void);
